/**************************************************************************************************
  Filename:       hal_adf4113.h
  Revised:        $Date: 2013-11-17 $
  Revision:       $Revision: $
  Description:    This file contains the interface to the ADF4113 frequency synthesizer.
**************************************************************************************************/
#ifndef HAL_ADF4113_H
#define HAL_ADF4113_H
#include "main.h"

typedef struct _PLL_Setting_st{
    GPIO_TypeDef * PLL_CLK_PORT;
    uint16_t       PLL_CLK_PIN;
    GPIO_TypeDef * PLL_DATA_PORT;
    uint16_t       PLL_DATA_PIN;
    GPIO_TypeDef * PLL_ENABLE_PORT;
    uint16_t       PLL_ENABLE_PIN;
} PLL_Setting_st;

PLL_Setting_st ADF4113_1_8G_DL;
PLL_Setting_st ADF4113_1_8G_UL;
PLL_Setting_st ADF4113_2_1G_DL;
PLL_Setting_st ADF4113_2_1G_UL;

uint8_t halSynSetFreq(uint32_t rf_Freq);
void ADF4113_Module_Ctrl(PLL_Setting_st pll,uint32_t R0,uint32_t R1,uint32_t R2);
void ADF4113_Initialize(void);

//void ADF4113_Module_Ctrl(PLL_Setting_st pll,uint32_t R0,uint32_t R1,uint32_t R2);

#endif
